#ifndef BLMSPF_H
#define BLMSPF_H

#define MAX_BLMSPF_ERROR				1024
#define MAX_BLMSPF_VERSION				32
#define BLMSPF_PASSWORD_LENGTH			32
#define	DEFAULT_BLMSPF_BAUD				9600

#define BLMSPF_NULL_ID					0
#define BLMSPF_HOST_ID					1
#define BLMSPF_REMOTE_ID				2

#define BLMSPF_FILE_TYPE_TI_TEXT		1
#define BLMSPF_FILE_TYPE_INTEL_HEX		2

#define BLMSPF_MSG_TYPE_TEXT			0x00000001
#define BLMSPF_MSG_TYPE_NAMED_TEXT		0x00000002
#define BLMSPF_MSG_TYPE_BUFFER			0x00000004
#define BLMSPF_MSG_TYPE_PROGRESS		0x00000008
#define BLMSPF_MSG_TYPE_ALL				0xFFFFFFFF

#define BLMSPF_PROGRESS_TYPE_INIT_TARGET	201
#define BLMSPF_PROGRESS_TYPE_RESET_TARGET	202
#define BLMSPF_PROGRESS_TYPE_WRITE_FILE		203
#define BLMSPF_PROGRESS_TYPE_READ_FILE		204
#define BLMSPF_PROGRESS_TYPE_VERIFY_FILE	205

// Callback messages use SendMessage to call the handler immediately
// WPARAM is message type

typedef struct tagBLMSPF_MSG_TEXT
{	BOOL bCRLF;
	LPCTSTR szText;
} BLMSPF_MSG_TEXT; 

typedef struct tagBLMSPF_MSG_NAMEDTEXT
{	int nID;
	LPCTSTR szText;
} BLMSPF_MSG_NAMEDTEXT; 

typedef struct tagBLMSPF_MSG_BUFFER
{	int nID;
	DWORD dwSize;
	LPBYTE pbyBuffer;
} BLMSPF_MSG_BUFFER; 

typedef struct tagBLMSPF_MSG_PROGRESS
{	int nProgressType;
	int nProgress;
	int nMax;
} BLMSPF_MSG_PROGRESS; 

#ifdef __cplusplus
extern "C" 
{
#endif /* __cplusplus */

BOOL WINAPI Open_BLMSPF( LPCTSTR szPort, DWORD dwBaud );
void WINAPI Close_BLMSPF( void );
BOOL WINAPI IsOpen_BLMSPF();
DWORD WINAPI GetLastError_BLMSPF( LPTSTR szBuffer, DWORD dwBufferSize );
LPCTSTR WINAPI GetVersion_BLMSPF( void );
void WINAPI RegisterHWND_BLMSPF( HWND hWnd, UINT nMsgID, DWORD dwMask );
BOOL WINAPI SetPatchFile_BLMSPF( LPCTSTR szPatchFileName );
BOOL WINAPI InitializeAdapter_BLMSPF();
BOOL WINAPI GetAdapterInfo_BLMSPF( LPWORD pwVersion, LPDWORD pdwSerNum );
BOOL WINAPI ResetTarget_BLMSPF();
BOOL WINAPI PowerOn_BLMSPF();
BOOL WINAPI PowerOff_BLMSPF();
BOOL WINAPI SetPasswordData_BLMSPF( LPBYTE abyPassword );
BOOL WINAPI GetPasswordData_BLMSPF( LPBYTE pBuffer, DWORD dwBufferSize, LPDWORD pdwBytesRead );
BOOL WINAPI GetBootloaderVersion_BLMSPF( LPBYTE pMajorVersion, LPBYTE pMinorVersion );
LPCTSTR WINAPI GetProcessorType_BLMSPF();
BOOL WINAPI InitializeTarget_BLMSPF( BOOL bForcePower );
BOOL WINAPI MassErase_BLMSPF();
BOOL WINAPI WriteFile_BLMSPF( LPCTSTR szFileName, int nFileType, BOOL bWithVerify );
BOOL WINAPI ReadFile_BLMSPF( LPCTSTR szFileName, int nFileType, DWORD dwAddress, DWORD dwSize );
BOOL WINAPI VerifyFile_BLMSPF( LPCTSTR szFileName, int nFileType );
BOOL WINAPI SetPasswordFile_BLMSPF( LPCTSTR szFileName, int nFileType );
BOOL WINAPI IsPatchRequired_BLMSPF();
BOOL WINAPI LoadPC_BLMSPF( DWORD dwAddress );
BOOL WINAPI SectorErase_BLMSPF( DWORD dwSectorAddress );
BOOL WINAPI RxData_BLMSPF( DWORD dwAddress, LPBYTE pBuffer, DWORD dwCount, LPDWORD pdwBytesRead );
BOOL WINAPI TxData_BLMSPF( DWORD dwAddress, LPBYTE pBuffer, DWORD dwCount, BOOL bWithVerify );
BOOL WINAPI VerifyData_BLMSPF( DWORD dwAddress, LPBYTE pBuffer, DWORD dwCount );
BOOL WINAPI PollTargetSignal_BLMSPF( LPBOOL pbSignal );
BOOL WINAPI PortTx_BLMSPF( LPBOOL pbSignal, LPBYTE pBuffer, DWORD dwCount );
BOOL WINAPI PortRx_BLMSPF( LPBOOL pbSignal, LPBYTE pBuffer, DWORD dwCount, LPDWORD pdwBytesRead );

#ifdef __cplusplus
} /* End of extern "C" { */
#endif /* __cplusplus */

#endif
